<?php

/**
 * Description of SurveyTool
 *
 * SurveyTool is where the survey can be created.
 * 
 */
class SurveyCreationTool {

    public function __construct() {
        SurveyCreationTool::javascript();
        ?>

        <div id="surveyCreation"><form action="submitsurvey.php" method="post">
                <?php
                SurveyCreationTool::titleBox();
                SurveyCreationTool::descriptionBox();
                SurveyCreationTool::questionCreationForm();
                SurveyCreationTool::addQuestionButton();
                SurveyCreationTool::submitButton();
                ?></form></div>
        <?php
    }

    private static function javascript() {
        ?>
        <script type="text/javascript">
            var questionCount = 1;           
                                                                                    
            function getNewQuestion()
            {
                var questionDiv = document.createElement("div");
                var htmlStr = 
                    "<div id='question" + questionCount + "' class='question'>" +
                    "<table class='questionTable'>" +
                    "<th>Question " + questionCount + "</th>" +
                    "<tr><td><label for='questionTitle'>Title</label></td>" + 
                    "<td><input type='text' class='questionTitle' name='questionTitle" + questionCount + "' size='30' value='Untitled Question' /></td></tr>" +
                    "<tr><td><label for='questionDescription'>Description</label></td>" + 
                    "<td><input type='text' class='questionDescription' name='questionDescription" + questionCount + "' size='60' value='Write a question description here.' /></td>" +
                    "<tr><td><label for='questionType'>Answer type</label></td>" + 
                    "<td><select id='" + questionCount + "' name='questionType" + questionCount + "' onchange='handleType(this)'><br />"+
                    "<option value='text' selected='selected'>Text</option>" +
                    "<option value='int'>Integer</option>" +
                    "<option value='mc'>Multiple choice</option>" +
                    "<option value='checkboxes'>Checkboxes</option>" +
                    "<option value='scale'>Scale</option>" +
                    "</select></td></tr>" +
                    "</table>" +
                    "<div id='answersDiv" + questionCount + "'></div>" +
                    "</div>";
                                                                                
                questionDiv.innerHTML = htmlStr;
                                                                                
                return questionDiv;
            }
                                                                                    
            function handleFocus(input)
            {
                if (input.clicked == null)
                {
                    input.value = "";
                    input.style.color = "black";   
                    input.clicked = true; 
                }
            }
                                                                                                                    
            function handleBlur(input)
            {        
                var surveyTitle = document.getElementById('surveyTitle');
                var surveyDescription = document.getElementById('surveyDescription');
                                                                                                    
                if (input.value == "")
                {
                    input.style.color = "gray";
                    input.clicked = null;
                                                                                                                            
                    if (input == surveyTitle)
                    {
                        input.value = "Untitled Survey";
                    }
                    else if (input == surveyDescription)
                    {
                        input.value = "Write a helpful description for this survey here.";
                    }
                }                           
            }
                                                                    
            function handleType(select)
            {
                var type = select.valueOf().value;
                var answersDiv = document.getElementById("answersDiv" +  select.id);
                answersDiv.answerCount = 1;
                answersDiv.clicked = null;
                        
                switch (type) {
                    case 'mc':
                        answersDiv.innerHTML = "";
                        addOption(select.id);
                                                        
                        break;
                    case 'text':
                        answersDiv.innerHTML = "";
                        break;
                    case 'int':    
                        answersDiv.innerHTML = "";
                        //min max
                        minMax(select.id);
                        break;
                    case 'checkboxes':
                        answersDiv.innerHTML = "";  
                        addOption(select.id);
                        break;
                    case 'scale':
                        answersDiv.innerHTML = ""; 
                        //what scale (min max incr)
                        break;
                    default:
                        break;
                }

            }
                                                    
                                            
            function addOption(questionNumber)
            {        
                var answersDiv = document.getElementById("answersDiv" + questionNumber);
                var answerCount = answersDiv.answerCount;
                var answerDiv = document.createElement("div");
                answerDiv.className = "answerDiv";
                                                
                var htmlStr = "<input type='text' name='q" + 
                    questionNumber + "ans" + answerCount + "' value='Option " + answerCount + "' />";
                        
                if (answersDiv.clicked == null)
                {
                    htmlStr += "<input type='button' id='addOpt'"
                        + " class='surveyButton' onclick='addOption(" + questionNumber + ")' value='Add Option' />";
                    answersDiv.clicked = true;
                }
                                                       
                answerDiv.innerHTML = htmlStr;
                                                       
                answersDiv.appendChild(answerDiv);
                answersDiv.answerCount++;
            }
            
            function minMax(questionNumber)
            {
               var answersDiv = document.getElementById("answersDiv" + questionNumber);
               
               var answerDiv = document.createElement("div");
               answerDiv.className = "answerDiv";
               answerDiv.innerHTML = "<label for='min'>Min</label><input type='text' name='min" + questionNumber + "' />" +
               "<label for='max'>Max</label><input type='text' name='max" + questionNumber + "' />";
           
                answersDiv.appendChild(answerDiv);
            }            
                                                                 
            function addQuestion()
            {
                var questionsDiv = document.getElementById('questionsDiv');
                var newQuestion = getNewQuestion();
                                                                                
                questionsDiv.appendChild(newQuestion);
                questionCount++;
            }
            
                                                                                                                                                                                            
        </script>
        <?php
    }

    private static function titleBox() {
        ?>
        <input type="text" id="surveyTitle" name="surveyTitle" value="Untitled Survey" size="30" onblur="handleBlur(this)" onfocus="handleFocus(this)" />
        <?php
    }

    private static function descriptionBox() {
        ?>
        <textarea id="surveyDescription" rows="3" cols="80" name="surveyDescription" onblur="handleBlur(this)" onfocus="handleFocus(this)">Write a helpful description for this survey here.</textarea>
        <?php
    }

    private static function questionCreationForm() {
        ?>
        <div id='questionsDiv'>
        </div>
        <script type="text/javascript"> addQuestion(); </script>
        <?php
    }

    private static function addQuestionButton() {
        ?>
        <input id="addQuestionButton" type="button" onclick="addQuestion()" value="Add New Question" class="surveyButton" />
        <?php
    }

    private static function submitbutton() {
        ?>
        <input type="submit" name="submitSurvey" 
               value="Submit Survey!" class="surveyButton" id="submitSurvey"/>
        <?php
    }

}
?>
